Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5075)
@@ -1053,23 +2585,44 @@
             jj = il_ill(2)
 
-            IF( ABS(td_lon0%d_value(ji,jj,1,1)-dl_lon1_ll) > dl_dlon*1.e-3 )THEN
-               IF(td_lon0%d_value(ji,jj,1,1) > dl_lon1_ll ) il_ill(1)=il_ill(1)-1
+            IF( ABS(tl_lon0%d_value(ji,jj,1,1)-dl_lon1_ll) > dp_delta )THEN
+               IF(tl_lon0%d_value(ji,jj,1,1) > dl_lon1_ll )THEN
+                  il_ill(1)=il_ill(1)-1
+                  IF( il_ill(1) <= 0 )THEN
+                     IF( tl_lon0%i_ew >= 0 )THEN
+                        il_ill(1)=tl_lon0%t_dim(jp_I)%i_len-tl_lon0%i_ew
+                     ELSE
+                        CALL logger_error("GRID GET COARSE INDEX: error "//&
+                        &                 "computing lower left corner "//&
+                        &                 "index for longitude")
+                     ENDIF
+                  ENDIF
+               ENDIF
             ENDIF
-            IF( ABS(td_lat0%d_value(ji,jj,1,1)-dl_lat1_ll) > dl_dlat*1.e-3 )THEN
-               IF(td_lat0%d_value(ji,jj,1,1) > dl_lat1_ll ) il_ill(2)=il_ill(2)-1
+            IF( ABS(tl_lat0%d_value(ji,jj,1,1)-dl_lat1_ll) > dp_delta )THEN
+               IF(tl_lat0%d_value(ji,jj,1,1) > dl_lat1_ll )THEN
+                  il_ill(2)=il_ill(2)-1
+                  IF( il_ill(2)-1 <= 0 )THEN
+                     CALL logger_error("GRID GET COARSE INDEX: error "//&
+                     &                 "computing lower left corner "//&
+                     &                 "index for latitude")
+                  ENDIF
+               ENDIF
             ENDIF
 
             !2- search upper left corner indices
-            dl_lon1_ul=td_lon1%d_value( il_imin1, il_jmax1, 1, 1 )
-            dl_lat1_ul=td_lat1%d_value( il_imin1, il_jmax1, 1, 1 )
-
-            dl_dlon=ABS(td_lon1%d_value(il_imin1+1,il_jmax1  ,1,1)-dl_lon1_ll)
-            dl_dlat=ABS(td_lat1%d_value(il_imin1  ,il_jmax1-1,1,1)-dl_lat1_ll)
-            
+            dl_lon1_ul=tl_lon1%d_value( il_imin1, il_jmax1, 1, 1 )
+            dl_lat1_ul=tl_lat1%d_value( il_imin1, il_jmax1, 1, 1 )
+
+            IF( dl_lon1_ul == tl_lon1%d_fill .OR. &
+            &   dl_lat1_ul == tl_lat1%d_fill )THEN
+               CALL logger_error("GRID GET COARSE INDEX: upper left corner "//&
+               &                 "point is FillValue. remove ghost cell "//&
+               &                 "running grid_get_coarse_index.")
+            ENDIF            
             ! look for closest point on coarse grid
-            il_iul(:)= grid_get_closest(td_lon0%d_value(il_imin0:il_imax0, &
+            il_iul(:)= grid_get_closest(tl_lon0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
-            &                           td_lat0%d_value(il_imin0:il_imax0, &
+            &                           tl_lat0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
@@ -1080,23 +2633,45 @@
             jj = il_iul(2)
 
-            IF( ABS(td_lon0%d_value(ji,jj,1,1)-dl_lon1_ul) > dl_dlon*1.e-3 )THEN
-               IF(td_lon0%d_value(ji,jj,1,1) > dl_lon1_ul ) il_iul(1)=il_iul(1)-1
+            IF( ABS(tl_lon0%d_value(ji,jj,1,1)-dl_lon1_ul) > dp_delta )THEN
+               IF(tl_lon0%d_value(ji,jj,1,1) > dl_lon1_ul )THEN
+                  il_iul(1)=il_iul(1)-1
+                  IF( il_iul(1) <= 0 )THEN
+                     IF( tl_lon0%i_ew >= 0 )THEN
+                        il_iul(1)=tl_lon0%t_dim(jp_I)%i_len-tl_lon0%i_ew
+                     ELSE
+                        CALL logger_error("GRID GET COARSE INDEX: error "//&
+                        &                 "computing upper left corner "//&
+                        &                 "index for longitude")
+                     ENDIF
+                  ENDIF
+               ENDIF
             ENDIF
-            IF( ABS(td_lat0%d_value(ji,jj,1,1)-dl_lat1_ul) > dl_dlat*1.e-3 )THEN
-               IF(td_lat0%d_value(ji,jj,1,1) < dl_lat1_ul ) il_iul(2)=il_iul(2)+1
+
+            IF( ABS(tl_lat0%d_value(ji,jj,1,1)-dl_lat1_ul) > dp_delta )THEN
+               IF(tl_lat0%d_value(ji,jj,1,1) < dl_lat1_ul )THEN
+                  il_iul(2)=il_iul(2)+1
+                  IF( il_ill(2) > tl_lat0%t_dim(jp_J)%i_len )THEN
+                     CALL logger_error("GRID GET COARSE INDEX: error "//&
+                     &                 "computing upper left corner "//&
+                     &                 "index for latitude")
+                  ENDIF
+               ENDIF
             ENDIF
 
             !3- search lower right corner indices
-            dl_lon1_lr=td_lon1%d_value( il_imax1, il_jmin1, 1, 1 )
-            dl_lat1_lr=td_lat1%d_value( il_imax1, il_jmin1, 1, 1 )
-
-            dl_dlon=ABS(td_lon1%d_value(il_imax1-1,il_jmin1  ,1,1)-dl_lon1_ll)
-            dl_dlat=ABS(td_lat1%d_value(il_imax1  ,il_jmin1+1,1,1)-dl_lat1_ll)
-            
+            dl_lon1_lr=tl_lon1%d_value( il_imax1, il_jmin1, 1, 1 )
+            dl_lat1_lr=tl_lat1%d_value( il_imax1, il_jmin1, 1, 1 )
+
+            IF( dl_lon1_lr == tl_lon1%d_fill .OR. &
+            &   dl_lat1_lr == tl_lat1%d_fill )THEN
+               CALL logger_error("GRID GET COARSE INDEX: lower right corner "//&
+               &                 "point is FillValue. remove ghost cell "//&
+               &                 "running grid_get_coarse_index.")
+            ENDIF            
             ! look for closest point on coarse grid
-            il_ilr(:)= grid_get_closest(td_lon0%d_value(il_imin0:il_imax0, &
+            il_ilr(:)= grid_get_closest(tl_lon0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
-            &                           td_lat0%d_value(il_imin0:il_imax0, &
+            &                           tl_lat0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
@@ -1106,23 +2681,44 @@
             ji = il_ilr(1)
             jj = il_ilr(2)
-            IF( ABS(td_lon0%d_value(ji,jj,1,1)-dl_lon1_lr) > dl_dlon*1.e-3 )THEN
-               IF( td_lon0%d_value(ji,jj,1,1) < dl_lon1_lr ) il_ilr(1)=il_ilr(1)+1
+            IF( ABS(tl_lon0%d_value(ji,jj,1,1)-dl_lon1_lr) > dp_delta )THEN
+               IF( tl_lon0%d_value(ji,jj,1,1) < dl_lon1_lr )THEN
+                  il_ilr(1)=il_ilr(1)+1
+                  IF( il_ilr(1) > tl_lon0%t_dim(jp_I)%i_len )THEN
+                     IF( tl_lon0%i_ew >= 0 )THEN
+                        il_ilr(1)=tl_lon0%i_ew+1
+                     ELSE
+                        CALL logger_error("GRID GET COARSE INDEX: error "//&
+                        &                 "computing lower right corner "//&
+                        &                 "index for longitude")
+                     ENDIF
+                  ENDIF
+               ENDIF
             ENDIF
-            IF( ABS(td_lat0%d_value(ji,jj,1,1)-dl_lat1_lr) > dl_dlat*1.e-3 )THEN
-               IF( td_lat0%d_value(ji,jj,1,1) > dl_lat1_lr ) il_ilr(2)=il_ilr(2)-1
+            IF( ABS(tl_lat0%d_value(ji,jj,1,1)-dl_lat1_lr) > dp_delta )THEN
+               IF( tl_lat0%d_value(ji,jj,1,1) > dl_lat1_lr )THEN
+                  il_ilr(2)=il_ilr(2)-1
+                  IF( il_ilr(2) <= 0 )THEN
+                     CALL logger_error("GRID GET COARSE INDEX: error "//&
+                     &                 "computing lower right corner "//&
+                     &                 "index for latitude")
+                  ENDIF
+               ENDIF
             ENDIF
 
             !4- search upper right corner indices
-            dl_lon1_ur=td_lon1%d_value( il_imax1, il_jmax1, 1, 1 )
-            dl_lat1_ur=td_lat1%d_value( il_imax1, il_jmax1, 1, 1 )
-
-            dl_dlon=ABS(td_lon1%d_value(il_imax1-1,il_jmax1  ,1,1)-dl_lon1_ll)
-            dl_dlat=ABS(td_lat1%d_value(il_imax1  ,il_jmax1-1,1,1)-dl_lat1_ll)
-            
+            dl_lon1_ur=tl_lon1%d_value( il_imax1, il_jmax1, 1, 1 )
+            dl_lat1_ur=tl_lat1%d_value( il_imax1, il_jmax1, 1, 1 )
+
+            IF( dl_lon1_ur == tl_lon1%d_fill .OR. &
+            &   dl_lat1_ur == tl_lat1%d_fill )THEN
+               CALL logger_error("GRID GET COARSE INDEX: upper right corner "//&
+               &                 "point is FillValue. remove ghost cell "//&
+               &                 "running grid_get_coarse_index.")
+            ENDIF            
             ! look for closest point on coarse grid
-            il_iur(:)= grid_get_closest(td_lon0%d_value(il_imin0:il_imax0, &
+            il_iur(:)= grid_get_closest(tl_lon0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
-            &                           td_lat0%d_value(il_imin0:il_imax0, &
+            &                           tl_lat0%d_value(il_imin0:il_imax0, &
             &                                           il_jmin0:il_jmax0, &
             &                                           1,1), &
@@ -1132,9 +2728,27 @@
             ji = il_iur(1)
             jj = il_iur(2)
-            IF( ABS(td_lon0%d_value(ji,jj,1,1)-dl_lon1_ur) > dl_dlon*1.e-3 )THEN
-               IF( td_lon0%d_value(ji,jj,1,1) < dl_lon1_ur ) il_iur(1)=il_iur(1)+1
+            IF( ABS(tl_lon0%d_value(ji,jj,1,1)-dl_lon1_ur) > dp_delta )THEN
+               IF( tl_lon0%d_value(ji,jj,1,1) < dl_lon1_ur )THEN
+                  il_iur(1)=il_iur(1)+1
+                  IF( il_iur(1) > tl_lon0%t_dim(jp_I)%i_len )THEN
+                     IF( tl_lon0%i_ew >= 0 )THEN
+                        il_iur(1)=tl_lon0%i_ew+1
+                     ELSE
+                        CALL logger_error("GRID GET COARSE INDEX: error "//&
+                        &                 "computing upper right corner "//&
+                        &                 "index for longitude")
+                     ENDIF
+                  ENDIF
+               ENDIF
             ENDIF
-            IF( ABS(td_lat0%d_value(ji,jj,1,1)-dl_lat1_ur) > dl_dlat*1.e-3 )THEN
-               IF( td_lat0%d_value(ji,jj,1,1) < dl_lat1_ur ) il_iur(2)=il_iur(2)+1
+            IF( ABS(tl_lat0%d_value(ji,jj,1,1)-dl_lat1_ur) > dp_delta )THEN
+               IF( tl_lat0%d_value(ji,jj,1,1) < dl_lat1_ur )THEN
+                  il_iur(2)=il_iur(2)+1
+                  IF( il_iur(2) > tl_lat0%t_dim(jp_J)%i_len )THEN
+                     CALL logger_error("GRID GET COARSE INDEX: error "//&
+                     &                 "computing upper right corner "//&
+                     &                 "index for latitude")
+                  ENDIF
+               ENDIF
             ENDIF
 
@@ -1144,23 +2758,10 @@
 
             IF( il_imax <= il_ew0 )THEN
-               il_imax = td_lon0%t_dim(1)%i_len - il_ew0 + il_imax 
+               !il_imin = 1
+               il_imax = tl_lon0%t_dim(1)%i_len - il_ew0 + il_imax 
             ENDIF
 
             il_jmin = il_jmin0-1+MIN(il_ill(2), il_ilr(2))
             il_jmax = il_jmin0-1+MAX(il_iul(2), il_iur(2))
-
-            il_offset(:,:)= grid_get_fine_offset( td_lon0%d_value( :,:,1,1 ), &
-            &                                     td_lat0%d_value( :,:,1,1 ), &
-            &                                     il_imin, il_jmin, &
-            &                                     il_imax, il_jmax, &
-            &                                     td_lon1%d_value( :,:,1,1 ), &
-            &                                     td_lat1%d_value( :,:,1,1 ), &
-            &                                     il_rho(:) )
-
-            grid_get_coarse_index_cc(1,1,2) = il_offset(1,1)
-            grid_get_coarse_index_cc(1,2,2) = il_offset(1,2)
-
-            grid_get_coarse_index_cc(2,1,2) = il_offset(2,1)
-            grid_get_coarse_index_cc(2,2,2) = il_offset(2,2) 
 
             ! special case if east west overlap
@@ -1170,25 +2771,25 @@
 
                il_imin = 1
-               il_imax = 1
-
-               grid_get_coarse_index_cc(1,1,2) = 0
-               grid_get_coarse_index_cc(1,2,2) = 0
+               il_imax = tl_lon0%t_dim(1)%i_len
+
             ENDIF
-
          ENDIF
 
-         IF( il_imin == il_imax ) il_imax=td_lon0%t_dim(1)%i_len
-         IF( il_jmin == il_jmax ) il_jmax=td_lon0%t_dim(2)%i_len
-
-         grid_get_coarse_index_cc(1,1,1) = il_imin
-         grid_get_coarse_index_cc(1,2,1) = il_imax
-
-         grid_get_coarse_index_cc(2,1,1) = il_jmin
-         grid_get_coarse_index_cc(2,2,1) = il_jmax
+         grid__get_coarse_index_cc(1,1) = il_imin
+         grid__get_coarse_index_cc(1,2) = il_imax
+
+         grid__get_coarse_index_cc(2,1) = il_jmin
+         grid__get_coarse_index_cc(2,2) = il_jmax
  
-      ENDIF
-
-   END FUNCTION grid_get_coarse_index_cc
-   !> @endcode
+         ! clean 
+         CALL var_clean(tl_lon1)
+         CALL var_clean(tl_lat1)
+         CALL var_clean(tl_lon0)
+         CALL var_clean(tl_lat0)
+      ENDIF
+
+      DEALLOCATE( il_rho )
+
+   END FUNCTION grid__get_coarse_index_cc
    !-------------------------------------------------------------------
    !> @brief This function check if grid is global or not
@@ -1197,10 +2798,9 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_lon : longitude structure 
-   !> @param[in] td_lat : latitude structure 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_lon longitude structure 
+   !> @param[in] td_lat latitude structure 
+   !-------------------------------------------------------------------
    FUNCTION grid_is_global(td_lon, td_lat)
       IMPLICIT NONE
@@ -1233,5 +2833,5 @@
       IF( .NOT. ASSOCIATED(td_lon%d_value) .OR. &
       &   .NOT. ASSOCIATED(td_lat%d_value) )THEN
-         CALL logger_error("GRID IS GLOBAL: na value associated to "//&
+         CALL logger_error("GRID IS GLOBAL: no value associated to "//&
          &              " longitude or latitude strucutre")      
       ELSE
@@ -1256,28 +2856,23 @@
 
    END FUNCTION grid_is_global
-   !> @endcode
-
    !-------------------------------------------------------------------
    !> @brief This function return coarse grid indices of the closest point
    !> from fine grid point (lon1,lat1) 
    !> 
-   !
    !> @details
-   !
-   !> @note overlap band should have been already removed from coarse grid table 
+   !>
+   !> @note overlap band should have been already removed from coarse grid array 
    !> of longitude and latitude, before running this function
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_lon0 : coarse grid table of longitude
-   !> @param[in] dd_lat0 : coarse grid table of latitude
-   !> @param[in] dd_lon1 : fine   grid longitude
-   !> @param[in] dd_lat1 : fine   grid latitude
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] dd_lon0   coarse grid array of longitude
+   !> @param[in] dd_lat0   coarse grid array of latitude
+   !> @param[in] dd_lon1   fine   grid longitude
+   !> @param[in] dd_lat1   fine   grid latitude
    !> @return coarse grid indices of closest point of fine grid point
    !>
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !-------------------------------------------------------------------
    FUNCTION grid_get_closest( dd_lon0, dd_lat0, dd_lon1, dd_lat1  )
       IMPLICIT NONE
@@ -1326,5 +2921,5 @@
       IF( dd_lon1 < 0 ) dl_lon1 = dd_lon1 + 360.
 
-      !1- first, use dichotomy to reduce domain
+      ! first, use dichotomy to reduce domain
       il_iinf = 1              ; il_jinf = 1
       il_isup = il_shape(1)    ; il_jsup = il_shape(2)
@@ -1336,5 +2931,5 @@
       ll_continue=.TRUE.
 
-      !1-1 look for meridian 0°/360°
+      ! look for meridian 0°/360°
       il_jmid = il_jinf + INT(il_shape(2)/2)
       il_ind(:) = MAXLOC( dl_lon0(:,il_jmid), dl_lon0(:,il_jmid) <= 360._dp )
@@ -1378,5 +2973,5 @@
       ENDIF
 
-      !1-2
+      !
       DO WHILE( ll_continue .AND. .NOT. ll_north )
 
@@ -1401,5 +2996,4 @@
 
             ENDIF
-
 
             IF( dd_lat1 > dd_lat0(il_imid,il_jmid) )THEN
@@ -1430,5 +3024,5 @@
       ENDDO
 
-      !2- then find closest point by computing distances
+      ! then find closest point by computing distances
       il_shape(1)= il_isup - il_iinf + 1
       il_shape(2)= il_jsup - il_jinf + 1
@@ -1449,20 +3043,18 @@
 
    END FUNCTION grid_get_closest
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function compute the distance between a point A and 
-   !> points of a grid  
+   !-------------------------------------------------------------------
+   !> @brief This function compute the distance between a point A and grid points.  
    !
    !> @details
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_lon : grid longitude table
-   !> @param[in] dd_lat : grid latitude  table
-   !> @param[in] dd_lonA : longitude of point A
-   !> @param[in] dd_latA : latitude  of point A
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] dd_lon    grid longitude array
+   !> @param[in] dd_lat    grid latitude  array
+   !> @param[in] dd_lonA   longitude of point A
+   !> @param[in] dd_latA   latitude  of point A
+   !> @return array of distance between point A and grid points.
+   !-------------------------------------------------------------------
    FUNCTION grid_distance(dd_lon, dd_lat, dd_lonA, dd_latA)
       IMPLICIT NONE
@@ -1507,9 +3099,9 @@
       IF(   dd_lonA     < 0 ) dl_lonA     = dd_lonA     + 360.
       
-      dl_lonA = dd_lonA * dg_deg2rad
-      dl_latA = dd_latA * dg_deg2rad
-
-      dl_lon(:,:) = dl_lon(:,:) * dg_deg2rad
-      dl_lat(:,:) = dd_lat(:,:) * dg_deg2rad
+      dl_lonA = dd_lonA * dp_deg2rad
+      dl_latA = dd_latA * dp_deg2rad
+
+      dl_lon(:,:) = dl_lon(:,:) * dp_deg2rad
+      dl_lat(:,:) = dd_lat(:,:) * dp_deg2rad
 
       grid_distance(:,:)=NF90_FILL_DOUBLE
@@ -1518,5 +3110,5 @@
          DO ji=1,il_shape(1)
             IF( dl_lon(ji,jj) == dl_lonA .AND. &
-            &   dl_lat(ji,jj) == dl_lATA )THEN
+            &   dl_lat(ji,jj) == dl_laTA )THEN
                grid_distance(ji,jj)=0.0
             ELSE
@@ -1526,5 +3118,5 @@
                IF( dl_tmp < -1.0 ) dl_tmp = -1.0
                IF( dl_tmp >  1.0 ) dl_tmp =  1.0
-               grid_distance(ji,jj)=ACOS(dl_tmp)*dg_rearth
+               grid_distance(ji,jj)=ACOS(dl_tmp)*dp_rearth
             ENDIF
          ENDDO
